//Chinesecheckers.cpp

//Header Files
#include <iomanip>
#include <math.h>
#include "ezwin.h"
#include <cassert>
#include <string.h>
#include <assert.h>
#include "bitmap.h"
#include <fstream>
#include "screen.cc"

float gx(float x) {
return x*1024/srx;
}

float gy(float y) {
return y*768/sry;
}

#include "checkbox.cc"
#include "declerations.cc"
#include "gameoptions.cc"
#include "complogic.cc"
#include "graphics.cc"
#include "userplay.cc"

/*=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=MAIN BODY=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=*/


/*=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=func14=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=*/
//mouseclick for main window
int mouseclick(const Position &pointer)
{
if (anicounter != 0)
	return 0;
float a,b,p,q,x,y;
x=pointer.GetXDistance()/gx(1);
y=pointer.GetYDistance()/gy(1);
//Grid conversion
p=floor(((y-origin.GetYDistance())/sqrt(3.0)-(x-origin.GetXDistance()))/unitd + 0.5);
q=floor(((y-origin.GetYDistance())/sqrt(3.0)+(x-origin.GetXDistance()))/unitd + 0.5);
if(Newgame.IsInside(pointer))
{
savepromptdata = 1;
saveprompt();
}

else if(Savegame.IsInside(pointer))
{
dosave=true;
savepromptdata = 0;
saveloadgame();
}

else if(Loadgame.IsInside(pointer))
{
savepromptdata = 2;
saveprompt();
}

else if(Rules.IsInside(pointer))
{
   RulesWin.Open();
   assert(RulesWin.GetStatus() == WindowOpen);

   ruleimage.Load("../lib/images/rules.xpm");
   assert(ruleimage.GetStatus() == BitMapOkay);
   ruleimage.SetPosition(Position(0, 0));
   ruleimage.Draw();

}

else if(Setting.IsInside(pointer))
{
	showsetting();
}

else if(Exit.IsInside(pointer))
{
savepromptdata = 3;
saveprompt();
}

//player move
else if((p>=-4 && p<=13) && (q>=-4 && q<=13))
{	
	if(!(islifted))
	{
      liftball(int(p),int(q));
	}
	else
	{
      dropball(int(p),int(q));
	}

}
if(usercontinued && Done.IsInside(pointer))
{
	islifted = false;
	usercontinued = false;
	//nextstep();
	think();
}
}


/*=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=func0=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=*/
int ApiMain()
{
   IntroWin.Open();//Opens the main window
   assert(IntroWin.GetStatus() == WindowOpen);

   BitMap intro(IntroWin);
   intro.Load("../lib/images/start.xpm");
   assert(intro.GetStatus() == BitMapOkay);
   intro.SetPosition(Position(0.0, 0.0));
   intro.Draw();

IntroWin.SetTimerCallback(loadgamedata);
IntroWin.StartTimer(2000);
                                         
	 return 0;
}

/*=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=func00=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=*/
int ApiEnd()
{	
	RulesWin.Close();
	SavepromptWin.Close();
	SaveWin.Close();
	MainWin.Close();
	SettingWin.Close();
   return 0;
}


/*=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=func15=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=*/
int savepromptmouseclick(const Position &pointer)
{
float x,y;
x=pointer.GetXDistance();
y=pointer.GetYDistance();
if(Yes.IsInside(pointer))
	{
		dosave=true;
				saveloadgame();
				SavepromptWin.Close();
	}
else if(No.IsInside(pointer))
	{
		SavepromptWin.Close();
		if(savepromptdata == 1)
			{
				savepromptdata =0;
				set_board();
			}
		else if(savepromptdata ==2)
			{
				savepromptdata =0;
				dosave=false;
				saveloadgame();
			}
		else if(savepromptdata ==3)
			{
				savepromptdata =0;
				ApiEnd();
			}
	}
if(Cancel2.IsInside(pointer))
	{
		savepromptdata =0;
		SavepromptWin.Close();
	}
}


/*=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=func16=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=*/
int saveloadmouseclick(const Position &pointer)
{
int i=0;
fstream foo;
if(game1.IsInside(pointer))
	foo.open("../lib/data/game1.txt");
else if(game2.IsInside(pointer))
	foo.open("../lib/data/game2.txt");
else if(game3.IsInside(pointer))
	foo.open("../lib/data/game3.txt");
else if(game4.IsInside(pointer))
	foo.open("../lib/data/game4.txt");
else if(game5.IsInside(pointer))
	foo.open("../lib/data/game5.txt");
else
	i=1;
if(i==0)
{
	if(dosave)	
	{	
		for(i=0;i<10;i++)
			{
				foo<<compcell[i][0]<<" ";
				foo<<compcell[i][1]<<" ";
			}
		for(i=0;i<10;i++)
			{
				foo<<usercell[i][0]<<" ";
				foo<<usercell[i][1]<<" ";
			}
	}
	else
	{
		set_board1(foo);
	}
	SaveWin.Close();
	foo.close();
				if(savepromptdata == 1)
					{
						savepromptdata =0;
						set_board();
					}
				else if(savepromptdata ==2)
					{
						savepromptdata =0;
						dosave=false;
						saveloadgame();
					}
				else if(savepromptdata ==3)
					{
						savepromptdata =0;
						ApiEnd();

					}
}
}


/*=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=func22=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=*/

int loadgamedata()
{
	IntroWin.Close();
	MainWin.Open();//Opens the main window
	assert(MainWin.GetStatus() == WindowOpen);
   Backphoto.Load("../lib/images/f1.xpm");
   assert(Backphoto.GetStatus() == BitMapOkay);
   Backphoto.SetPosition(Position(gx(0.3), gy(0.3)));// Display th   Background.Load("f1.xpm");

   Setting.Load("../lib/images/setting.xpm");
   assert(Setting.GetStatus() == BitMapOkay);
   Setting.SetPosition(Position(gx(11), gy(8.5)));// Display th   Background.Load("f1.xpm");

   Newgame.Load("../lib/images/new.xpm");
   assert(Newgame.GetStatus() == BitMapOkay);
   Newgame.SetPosition(Position(gx(11), gy(0.5)));// Display the bitmaps at a starting position

   Savegame.Load("../lib/images/save.xpm");
   assert(Savegame.GetStatus() == BitMapOkay);
   Savegame.SetPosition(Position(gx(11), gy(2.5)));// Display the bitmaps at a starting position

   Loadgame.Load("../lib/images/load.xpm");
   assert(Loadgame.GetStatus() == BitMapOkay);
   Loadgame.SetPosition(Position(gx(11), gy(4.5)));// Display the bitmaps at a starting position

   Rules.Load("../lib/images/rls.xpm");
   assert(Rules.GetStatus() == BitMapOkay);
   Rules.SetPosition(Position(gx(11), gy(6.5)));// Display the bitmaps at a starting position


   Exit.Load("../lib/images/exit.xpm");
   assert(Exit.GetStatus() == BitMapOkay);
   Exit.SetPosition(Position(gx(11), gy(10.5)));// Display the bitmaps at a starting position

   Done.Load("../lib/images/done.xpm");
   assert(Done.GetStatus() == BitMapOkay);
   Done.SetPosition(Position(gx(0.3), gy(10.5)));


	MainWin.SetMouseClickCallback(mouseclick);// Register the call backs for each window
	MainWin.SetTimerCallback(animate);
	MainWin.SetQuitCallback(ApiEnd);

set_board();
}

/*=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=func27=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=*/
int settingclicked(const Position &pointer)
{
if (Easy.IsClicked(pointer))
{
	Easy.checked  = true;
	Hard.checked  = false;
	Easy.Display();
	Hard.Display();
}
else if (Hard.IsClicked(pointer))
{
	Hard.checked  = true;
	Easy.checked  = false;
	Easy.Display();
	Hard.Display();
}
else if (User.IsClicked(pointer))
{
	User.checked  = true;
	Comp.checked  = false;
	User.Display();
	Comp.Display();
}
else if (Comp.IsClicked(pointer))
{
	Comp.checked  = true;
	User.checked  = false;
	User.Display();
	Comp.Display();
}
else if (Fast.IsClicked(pointer))
{
	Fast.checked  = true;
	Slow.checked  = false;
	Fast.Display();
	Slow.Display();
}
else if (Slow.IsClicked(pointer))
{
	Slow.checked  = true;
	Fast.checked  = false;
	Fast.Display();
	Slow.Display();
}
else if (Ok.IsInside(pointer))
{
	if(Easy.checked)
		gamemode = 0;
	else
		gamemode = 1;

	if(User.checked)
		userplayfirst = true;
	else
		userplayfirst = false;

	if(Fast.checked)
		anitimer = 300;
	else
		anitimer = 500;

	SettingWin.Close();
}
else if (Cancel.IsInside(pointer))
	SettingWin.Close();


}
