//location of top hole = (5.000,0.314286)
//location of 12th hole = (0.314286,8.48571)
//so unitd=sqrt((x1-x2)*(x1-x2) + (y1-y2)*(y1-y2)) / 12

//Constants
const float marbleradius = 0.3;
const float unitd=sqrt((0.314286-5.000)*(0.314286-5.000) + (8.48571-0.314286)*(8.48571-0.314286))/12;
const Position origin=Position(5.000, 0.314286) + Position(.3,.3);
const int arr[20][2]={0,12,1,11,2,10,3,9,1,12,2,11,3,10,2,12,3,11,3,12  ,4,16,5,15,6,14,7,13,4,15,5,14,6,13,4,14,5,13,4,13};

//Graphics Part
SimpleWindow MainWin("Chinese Checkers",  gx(14.5),  gy(12.0), Position(0, 0));
SimpleWindow RulesWin("RULES",            gx(15.7),  gy(15.6), Position(0, 0));
SimpleWindow SavepromptWin("SAVE PROMPT", gx(05.0),  gy(02.0), Position(0, 0));
SimpleWindow SaveWin("SAVE/LOAD GAME",    gx(03.0),  gy(06.5), Position(0, 0));
SimpleWindow IntroWin("Chinese Checkers", gx(11.0),  gy(10.5), Position(0, 0));
SimpleWindow SettingWin("Setting",        gx(04.0),  gy(09.0), Position(0, 0));

//Declaration of Bitmaps to be used
BitMap Backphoto(MainWin);
BitMap Newgame(MainWin);
BitMap Savegame(MainWin);
BitMap Loadgame(MainWin);
BitMap Rules(MainWin);
BitMap Exit(MainWin);
BitMap Done(MainWin);
BitMap Setting(MainWin);
BitMap Yes(SavepromptWin);
BitMap No(SavepromptWin);
BitMap Cancel2(SavepromptWin);

BitMap game1(SaveWin);
BitMap game2(SaveWin);
BitMap game3(SaveWin);
BitMap game4(SaveWin);
BitMap game5(SaveWin);
BitMap ruleimage(RulesWin);

BitMap Ok(SettingWin);
BitMap Cancel(SettingWin);

enum occupancy {comp=0,user=1,empty=2,undefined=3};//for defining board`s occupancy

//For determining best move for the comp 
struct  minvalue
{
int finalval;
int path[20][2];
int N;
};


struct pos
{
int p;
int q;
};


//Global Variables
pos balllifted;
float r=0.3;
occupancy board[17][17];
int compcellstart[10][2]={{0,0},{1,0},{2,0},{3,0},{0,1},{0,2},{0,3},{1,1},{1,2},{2,1}};
int usercellstart[10][2]={{8,8},{8,7},{8,6},{8,5},{7,8},{6,8},{5,8},{6,7},{7,6},{7,7}};
int usercell[10][2],compcell[10][2];
int cur_peg;
bool islifted,usercontinued,dosave;
int savepromptdata=0; // 0 = default , 1 = new, 2 = load, 3 = exit; 
minvalue anidata;
int anicounter =0;
bool compthink=true, gamemode = 1, userplayfirst = true;
int anitimer = 300;

//Setting Buttons
Button Easy(SettingWin);
Button Hard(SettingWin);
Button Slow(SettingWin);
Button Fast(SettingWin);
Button User(SettingWin);
Button Comp(SettingWin);


//Functions
void drawboard();//1  graphics.cc
void set_board();//2   gameoptions.cc
void set_board1(fstream &foo);//3   gameoptions.cc

void nextstep(int cellarray[10][2],minvalue minval1[10]);//4    complogic.cc
void pathfinder(pos &curcell,minvalue &minvalk,int &N,int temppath[20][2]);//5    complogic.cc
bool checkpath(pos &cp,int temppath[20][2],int &N);//6    complogic.cc
int calcvalue(int m, int n);//7    complogic.cc
int value(int m,int n);//8    complogic.cc

void compplay(minvalue minval, int m);//10    complogic.cc

void liftball(int p, int q);//11    userplay.cc
void dropball(int p,int q);//12    userplay.cc
void moveball(pos newpos, pos oldpos);//13    userplay.cc

int mouseclick(const Position &pointer);//14     cc.cpp
int savepromptmouseclick(const Position &pointer);//15     cc.cpp
int saveloadmouseclick(const Position &pointer);//16     cc.cpp

void saveloadgame();//17   gameoptions.cc
void saveprompt();//18   gameoptions.cc

occupancy checkwin();//19    complogic.cc

void updateusercell();//20    complogic.cc
int animate(); //21  graphics.cc

int loadgamedata();//22     cc.cpp

void think();//23    complogic.cc
void thinkmode0();//24    complogic.cc
void thinkmode1();//25    complogic.cc
void showsetting();//26   gameoptions.cc

int settingclicked(const Position &pointer);//27     cc.cpp
